#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_DaySigninCFG.h"
std::auto_ptr<M_DaySigninCFG> M_DaySigninCFG::msSingleton(nullptr);

int M_DaySigninCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_DaySigninCFGData* M_DaySigninCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_DaySigninCFGData>& M_DaySigninCFG::GetMapData()
{
	return mMapData;
}

void M_DaySigninCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_DaySigninCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_DaySigninCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		data.mReceive = element->IntAttribute("Receive");
		data.mShowResource = element->Attribute("ShowResource");
		data.mValue = element->IntAttribute("Value");
		data.mType = element->IntAttribute("Type");
		data.mParameter = element->IntAttribute("Parameter");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_DaySigninCFG Loaded. Load Data:%u", mMapData.size());
}

void M_DaySigninCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_DaySigninCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_DaySigninCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_DaySigninCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "Receive", data.mReceive);
		LuaCfgHelper::readString(L, "ShowResource", data.mShowResource);
		LuaCfgHelper::readInt(L, "Value", data.mValue);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Parameter", data.mParameter);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_DaySigninCFG Loaded. Load Data:%u", mMapData.size());
}

void M_DaySigninCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_DaySigninCFG* M_DaySigninCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_DaySigninCFG());
	}
	return msSingleton.get();
}

void M_DaySigninCFG::Release()
{
	msSingleton.reset(nullptr);
}
